/*
 * Created on Aug 6, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package gui;

import java.util.Set;

import net.sf.hibernate.HibernateException;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.TableEditor;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.ToolBar;
import org.eclipse.swt.widgets.ToolItem;
import dataaccess.GoodDAO;
import entity.GoodEntity;


/**
 * @author Hossien Hojjat
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class GoodComposite extends Composite 
{
	/**
	 * parent shell
	 */
	Shell shell;
	
	/**
	 * the composite table
	 */
	Table table;
	
	/**
	 * the composite table editor
	 */
	TableEditor editor;
	/**
	 * Class for showing the goods in the table
	 */
	private ShowGoods showGoods;
	

	public GoodComposite(Composite parent, Shell shell) 
	{
		super(parent, SWT.BORDER);
		setShell(shell);
		table = new Table(this, SWT.BORDER | SWT.FULL_SELECTION);
		showGoods = new ShowGoods( table, shell);
		createContents();
	}
	/**
     * sets the group on the dialog box
     *
     */
    private void makeGroup()
	{
		Group group = new Group( this, SWT.LEFT);
		FormData groupFD = new FormData();
		groupFD.top = new FormAttachment( 65);
		groupFD.bottom = new FormAttachment( 90);
		groupFD.left = new FormAttachment( 20);
		groupFD.right = new FormAttachment( 80);
		group.setLayoutData( groupFD);
	    
		group.setLayout( new FormLayout());
		
		// a button for adding rows to table
		Button button1 = new Button(group, SWT.PUSH);
	    button1.setText( "   ");
	    FormData button1FD = new FormData();
		button1FD.top = new FormAttachment( 5);
		button1FD.bottom = new FormAttachment( 30);
	    button1FD.left = new FormAttachment( 20);
	    button1FD.right = new FormAttachment( 80);
	    button1.setLayoutData( button1FD);
	    button1.setToolTipText("      ");
	    button1.addSelectionListener( new SelectionAdapter()
   		{
	    	public void widgetSelected(SelectionEvent e) 
	    	{
	    		TableItem newItem = new TableItem( table, SWT.NONE);
	    		newItem.setText(new String[] {
						"",
						"0",
						" ",
						"_" });
	    	}

   		});
	    
	    // a button for updating database 
	    Button button2 = new Button(group, SWT.PUSH);
	    button2.setText( " ");
	    FormData button2FD = new FormData();
		button2FD.top = new FormAttachment( 32);
		button2FD.bottom = new FormAttachment( 56);
	    button2FD.left = new FormAttachment( 20);
	    button2FD.right = new FormAttachment( 80);
	    button2.setLayoutData( button2FD);
	    button2.setToolTipText("       ");
	    button2.addSelectionListener( new SelectionAdapter()
   		{
	    	public void widgetSelected(SelectionEvent e) 
	    	{
	    		int selection = table.getSelectionIndex(); 
	    		TableItem delItem = table.getItem( selection);
	    		String IdText = delItem.getText( 3);
	    		if ( IdText.compareTo("_") == 0)
	    			return;
	    		Long delID = new Long( IdText);
	    		try
				{
	    			GoodEntity goodEntity = (GoodEntity) GoodDAO.findByID( delID);
	    			Set havalehListGoodSet = goodEntity.getHavalehListGoodSet();
	    			Object[] havalehListGoodArray = havalehListGoodSet.toArray();
	    			if( !havalehListGoodSet.isEmpty())
	    				throw( new Exception( "       "));
	    				
	    			GoodDAO.delete( delID);
	    			showGoods.refreshTable();			
				}catch ( Exception e1) 
				{
					Error error = new Error( e1.getMessage(), shell);
					e1.printStackTrace();
				}
	    	}

   		});

	    
	    // 	a button for updating database 
	    Button button3 = new Button(group, SWT.PUSH);
	    button3.setText( " ");
	    FormData button3FD = new FormData();
		button3FD.top = new FormAttachment( 70);
		button3FD.bottom = new FormAttachment( 95);
	    button3FD.left = new FormAttachment( 20);
	    button3FD.right = new FormAttachment( 80);
	    button3.setLayoutData( button3FD);
	    button3.setToolTipText("      ");
	    button3.addSelectionListener( new UpdateStock( table, shell, showGoods));
	}
    
	/**
	 * making the table component
	 *
	 */
    private void makeTable()
	{
    	table.setLinesVisible(true);
		FormData fd = new FormData();

		// setting the attachments of the form
		fd.top = new FormAttachment( 10);
		fd.bottom = new FormAttachment( 60);
	    fd.left = new FormAttachment( 15);
	    fd.right = new FormAttachment( 85);

		table.setLayoutData(fd);

		table.setLinesVisible(true);
		table.setHeaderVisible(true);
		TableColumn tc1 = new TableColumn(table, SWT.LEFT);
		tc1.setAlignment(SWT.CENTER);
		TableColumn tc2 = new TableColumn(table, SWT.CENTER);
		TableColumn tc3 = new TableColumn(table, SWT.CENTER);
		TableColumn tc4 = new TableColumn(table, SWT.CENTER);
		
		// setting the texts and the widths of the table columns
		tc1.setText("");
		tc2.setText("");
		tc3.setText(" ");
		tc4.setText("");

		tc1.setWidth(150);
		tc2.setWidth(90);
		tc3.setWidth(90);
		tc4.setWidth(50);

		table.setHeaderVisible(true);
		ToolBar toolBar = new ToolBar(this, SWT.HORIZONTAL);

		ToolItem item = new ToolItem( toolBar, SWT.PUSH);
		item.setText(" ");
		item.setToolTipText("          ");
		toolBar.pack();
		item.addSelectionListener( new SelectionAdapter()
				{
					public void widgetSelected(SelectionEvent e)
					{
						//showGoods.setTable( table);
						//showGoods.setShell( shell);
						showGoods.refreshTable();												
					}
				});
		editor = new TableEditor(table);
		editor.horizontalAlignment = SWT.LEFT;
		editor.grabHorizontal = true;
		table.addListener(SWT.MouseDown, new ClickMouseOnGoodTableListener( table, editor));
	}
    /**
     * creates the contents of the main window
     *
     */
	protected void createContents() 
	{
		this.setLayout( new FormLayout());
		makeTable();
		makeGroup();
		this.pack();
		//shell.open();
	}

	/**
	 * @return Returns the shell.
	 */
	public Shell getShell() {
		return shell;
	}

	/**
	 * @param shell The shell to set.
	 */
	public void setShell(Shell shell) {
		this.shell = shell;
	}
}