package actions;

import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import dataaccess.GoodDAO;
import entity.GoodEntity;
import forms.GoodForm;

/**
 * @struts.action name="goodAF" path= "/goodcrud"

 * @struts.action-forward name="good" path="/jsps/good.jsp"
 * @struts.action-forward name="good.update" path="/jsps/good.update.jsp"
 * @struts.action-forward name="good.list" path="/jsps/good.list.jsp"
 * @struts.action-forward name="error" path="/jsps/error.jsp"
 */
public class GoodCRUDAction extends BaseAction
{
    private GoodEntity goodEntity;

    public ActionForward execute(ActionMapping actionMapping, ActionForm actionForm, HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse) throws Exception 
	{
        String actionName = httpServletRequest.getParameter("Action_Name");
        goodEntity = ( GoodEntity) makeEntityFromForm(actionForm);

//        System.out.println("================>>>>>>>>>>>>");
//        System.out.println(goodEntity.getName());
//        System.out.println(goodEntity.getFamily());
//        System.out.println("================>>>>>>>>>>>>");

        if( actionName.equalsIgnoreCase("add")) {

            return actionMapping.findForward("good");

        } else if( actionName.equalsIgnoreCase("commitAdd")) {

            GoodDAO.save(goodEntity);
            List list = GoodDAO.list();
            httpServletRequest.getSession().setAttribute("GoodList", list);
            return actionMapping.findForward("good.list");

        } else if( actionName.equalsIgnoreCase("update")) {

            String ID = httpServletRequest.getParameter("ID");
            Long goodID = Long.decode(ID);

            GoodEntity tde = (GoodEntity) GoodDAO.findByID(goodID);

            httpServletRequest.getSession().setAttribute("Good", makeFormFromEntity( tde));
            httpServletRequest.getSession().setAttribute("ID", ID);

            return actionMapping.findForward("good.update");

        } else if( actionName.equalsIgnoreCase("commitUpdate")) {

            Long ID = Long.decode((String)httpServletRequest.getSession().getAttribute("ID"));

            GoodDAO.update(ID, goodEntity);

            List list = GoodDAO.list();
            httpServletRequest.getSession().setAttribute("GoodsList", list);

            return actionMapping.findForward("good.list");

        } else if( actionName.equalsIgnoreCase("list")) {

            List list = GoodDAO.list();
            httpServletRequest.getSession().setAttribute("GoodsList", list);

            return actionMapping.findForward("good.list");

        }

        return actionMapping.findForward("error");
    }

    protected Object makeEntityFromForm(ActionForm actionForm) 
    {
        GoodForm gForm = (GoodForm) actionForm;
        GoodEntity gEntity = new GoodEntity();

        gEntity.setCost( gForm.getCost());
        gEntity.setDescription( gForm.getDescription());
        gEntity.setStockState( gForm.getStockState());

        return gEntity;
    }

    protected ActionForm makeFormFromEntity( Object o) 
    {
        GoodEntity gEntity = (GoodEntity) o;
        GoodForm gForm = new GoodForm();

        gForm.setDescription( gEntity.getDescription());
        gForm.setStockState( gEntity.getStockState());
        gForm.setCost( gEntity.getCost());

        return gForm;
    }
}
