package actions;

import java.sql.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import dataaccess.ProductionOrderDAO;
import dataaccess.SentHavalehDAO;
import entity.HavalehListGoodEntity;
import entity.ProductionOrderEntity;
import entity.SentHavalehEntity;
import entity.TransportationDocumentEntity;

/**
 * @struts.action path= "/productionmanager"

 * @struts.action-forward name="directorder" path="/jsps/directorder.jsp"
 * @struts.action-forward name="productionlistgood.list" path="/jsps/productionlistgood.list.jsp"
 * @struts.action-forward name="productionorder.list" path="/jsps/productionorder.list.jsp"
 * @struts.action-forward name="error" path="/jsps/error.jsp"
 */
public class ProductionManagerAction extends BaseAction{
    private ProductionOrderEntity productionOrderEntity;
    private TransportationDocumentEntity transportationDocumentEntity;

    public ActionForward execute(ActionMapping actionMapping, ActionForm actionForm, HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse) throws Exception {
    	try {
	        String actionName = httpServletRequest.getParameter("Action_Name");
	        String ID = httpServletRequest.getParameter("ID");
	
	        productionOrderEntity = new ProductionOrderEntity();
	        transportationDocumentEntity = new TransportationDocumentEntity();
	        Date d = new Date(System.currentTimeMillis());
	        productionOrderEntity.setDate(d);
	        transportationDocumentEntity.setDate(d);

	        if( actionName == null)
	        	actionName = "list";
	        	        
	        if( actionName.equalsIgnoreCase("list")) {
	
	            List list = SentHavalehDAO.listProduce();
	
	            httpServletRequest.getSession().setAttribute("ProduceHavalehList", list);
	
	            return actionMapping.findForward("productionorder.list");
	        	
	        } else if( actionName.equalsIgnoreCase("listGoods")) {
	
	            Long sentHavalehID = Long.decode(ID);
	
	            SentHavalehEntity she = (SentHavalehEntity) SentHavalehDAO.findByID(sentHavalehID);
	            Set set = she.getHavalehListGoodSet();
	            
	            httpServletRequest.getSession().setAttribute("ProduceGoodList", set);
	
	            return actionMapping.findForward("productionlistgood.list");
	
	        } else if( actionName.equalsIgnoreCase("openTransport")) {
	
	        	SentHavalehEntity she = (SentHavalehEntity)SentHavalehDAO.findByID(new Long(Long.parseLong(ID)));
	            
	            she.setState("TRANSPORT");
	            she.getTransportationDocumentSet().add(transportationDocumentEntity);
	            transportationDocumentEntity.setSentHavalehEntity(she);
	            ProductionOrderDAO.transport( transportationDocumentEntity, she);
	        	
	            List list = SentHavalehDAO.listProduce();
	
	            httpServletRequest.getSession().setAttribute("ProduceHavalehList", list);
	
	            return actionMapping.findForward("productionorder.list");
	            
	        } else if( actionName.equalsIgnoreCase("closeProduce")) {
	
	            Long sentHavalehID = Long.decode(ID);
	
	            SentHavalehEntity she = (SentHavalehEntity) SentHavalehDAO.findByID(sentHavalehID);
	            
	            she.setState("PRODUCED");
	            SentHavalehDAO.save(she);
	            
	            httpServletRequest.getSession().setAttribute("ID", ID);
	
	            boolean ok = true;
	            Set set = she.getHavalehListGoodSet();
	            
	    	    for (Iterator it = set.iterator(); it.hasNext() && ok;) {
	    	        HavalehListGoodEntity havalehListGoodEntity = (HavalehListGoodEntity) it.next();
	    	        
	    	        if(havalehListGoodEntity.getGoodEntity().getStockState().intValue() < havalehListGoodEntity.getQuantity())
	    	        	ok = false;
	    	    }            
	            
	            if(ok) {
	            	return actionMapping.findForward("directorder");
	            } else {
		            List list = SentHavalehDAO.listProduce();
		
		            httpServletRequest.getSession().setAttribute("ProduceHavalehList", list);
		
		            return actionMapping.findForward("productionorder.list");
	            }
	            
	        }
    	} catch (Exception e) {
    		httpServletRequest.getSession().setAttribute("exception", e);
		}
    	
        return actionMapping.findForward("error");
    }

    protected Object makeEntityFromForm(ActionForm actionForm) {
        return null;
    }

    protected ActionForm makeFormFromEntity(Object o) {
        return null;
    }
}
