package actions;

import java.sql.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import dataaccess.ProductionOrderDAO;
import dataaccess.SentHavalehDAO;
import entity.HavalehListGoodEntity;
import entity.ProductionOrderEntity;
import entity.SentHavalehEntity;
import entity.TransportationDocumentEntity;
import forms.SentHavalehForm;

/**
 * @struts.action name="senthavalehAF" path= "/salemanager"

 * @struts.action-forward name="senthavaleh.list" path="/jsps/senthavaleh.list.jsp"
 * @struts.action-forward name="havalehlistgood.list" path="/jsps/havalehlistgood.list.jsp"
 * @struts.action-forward name="error" path="/jsps/error.jsp"
 */
public class SaleManagerAction extends BaseAction{
    private SentHavalehEntity sentHavalehEntity;
    private ProductionOrderEntity productionOrderEntity;
    private TransportationDocumentEntity transportationDocumentEntity;

    public ActionForward execute(ActionMapping actionMapping, ActionForm actionForm, HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse) throws Exception {
    	try {
	        String actionName = httpServletRequest.getParameter("Action_Name");
	        String ID = httpServletRequest.getParameter("ID");
	        sentHavalehEntity = (SentHavalehEntity) makeEntityFromForm(actionForm);
	
	        productionOrderEntity = new ProductionOrderEntity();
	        transportationDocumentEntity = new TransportationDocumentEntity();
	        Date d = new Date(System.currentTimeMillis());
	        productionOrderEntity.setDate(d);
	        transportationDocumentEntity.setDate(d);
	        
	        if( actionName == null)
	        	actionName = "list";
	        
	        if( actionName.equalsIgnoreCase("list")) {
	
	            List list = SentHavalehDAO.listReceived();
	
	            httpServletRequest.getSession().setAttribute("SentHavalehList", list);
	
	            return actionMapping.findForward("senthavaleh.list");
	
	        } else if( actionName.equalsIgnoreCase("listGoods")) {
	
	            Long sentHavalehID = Long.decode(ID);
	
	            SentHavalehEntity she = (SentHavalehEntity) SentHavalehDAO.findByID(sentHavalehID);
	            Set set = she.getHavalehListGoodSet();
	            
	            httpServletRequest.getSession().setAttribute("HavalehListGoodList", set);
	
	            return actionMapping.findForward("havalehlistgood.list");
	
	        } else if( actionName.equalsIgnoreCase("openProduce")) {
	
	        	SentHavalehEntity she = (SentHavalehEntity)SentHavalehDAO.findByID(new Long(Long.parseLong(ID)));
	            List hlg2bp = (List)httpServletRequest.getSession().getAttribute("HavalehListGoodToBeProduced");
	            
	            for (Iterator iter = hlg2bp.iterator(); iter.hasNext();) {            	
					HavalehListGoodEntity hlge = (HavalehListGoodEntity) iter.next();
					
					hlge.setProduce(true);
				}
	            
	            she.setState("PRODUCE");
	            she.getProductionOrderSet().add(productionOrderEntity);
	            productionOrderEntity.setSentHavalehEntity(she);
	            ProductionOrderDAO.order(hlg2bp, productionOrderEntity, she);
	        	
	            List list = SentHavalehDAO.listReceived();
	
	            httpServletRequest.getSession().setAttribute("SentHavalehList", list);
	
	            return actionMapping.findForward("senthavaleh.list");
	            
	        } else if( actionName.equalsIgnoreCase("openTransport")) {
	
	        	SentHavalehEntity she = (SentHavalehEntity)SentHavalehDAO.findByID(new Long(Long.parseLong(ID)));
	            
	            she.setState("TRANSPORT");
	            she.getTransportationDocumentSet().add(transportationDocumentEntity);
	            transportationDocumentEntity.setSentHavalehEntity(she);
	            ProductionOrderDAO.transport( transportationDocumentEntity, she);
	        	
	            List list = SentHavalehDAO.listReceived();
	
	            httpServletRequest.getSession().setAttribute("SentHavalehList", list);
	
	            return actionMapping.findForward("senthavaleh.list");
	            
	        }
    	} catch (Exception e) {
    		httpServletRequest.getSession().setAttribute("exception", e);
		}

        return actionMapping.findForward("error");
    }

    protected Object makeEntityFromForm(ActionForm actionForm) {
        SentHavalehForm shf = (SentHavalehForm) actionForm;
        SentHavalehEntity she = new SentHavalehEntity();

        she.setAddress(shf.getAddress());
        she.setTel(shf.getTel());
        Date d = new Date(System.currentTimeMillis());
        she.setDate(d);

        return she;
    }

    protected ActionForm makeFormFromEntity(Object o) {
        SentHavalehEntity she = (SentHavalehEntity) o;
        SentHavalehForm shf = new SentHavalehForm();

        shf.setAddress(she.getAddress());
        shf.setTel(she.getTel());
        shf.setDate(she.getDate());

        return shf;
    }
}
